# Issuer’s endpoint to handle VCAs initiate action flow. This endpoint will be used to inform the issuer about the initiate action flow in the VCAS process. # OpenAPI definition ```json { "openapi": "3.0.1", "info": { "title": "Card issuing - 3DS authentication", "description": "3DS API endpoint documentation.", "contact": { "name": "API Support", "email": "support@pismo.com.br", "url": "https://developers.pismo.io/support/" }, "license": { "name": "Copyright Pismo", "url": "https://developers.pismo.io/licenses/" }, "version": "1.0.0" }, "servers": [ { "url": "https://api-sandbox.pismolabs.io/3ds-acs", "description": "Sandbox API server for testing" } ], "tags": [ { "name": "VCAS", "description": "Endpoints to provide integration with VCAS." } ], "components": { "schemas": { "AccountV2": { "type": "object", "properties": { "id": { "$ref": "#/components/schemas/AccountID" }, "document_number": { "$ref": "#/components/schemas/DocumentNumber" }, "phones": { "type": "array", "items": { "$ref": "#/components/schemas/StructuredPhone" } }, "email": { "$ref": "#/components/schemas/Email" } } }, "AccountID": { "type": "integer", "description": "Pismo account ID", "example": 10045896 }, "Card": { "type": "object", "properties": { "id": { "$ref": "#/components/schemas/CardID" }, "mode_id": { "$ref": "#/components/schemas/CardModeID" }, "type": { "$ref": "#/components/schemas/CardType" }, "hash": { "$ref": "#/components/schemas/PANhash" }, "bin": { "$ref": "#/components/schemas/CardBIN" }, "last_four_digits": { "$ref": "#/components/schemas/CardLast4Digits" } } }, "CardBIN": { "type": "string", "description": "Card BIN (Bank Identification Number)", "example": "885692" }, "CardID": { "type": "integer", "description": "Card ID", "example": 869572 }, "CardLast4Digits": { "type": "string", "description": "Card last four PAN digits", "example": "0153" }, "CardModeID": { "type": "integer", "description": "Card mode ID", "example": 102 }, "CardType": { "type": "string", "description": "Card type", "enum": [ "PLASTIC", "VIRTUAL", "RECURRING", "TEMPORARY" ], "example": "PLASTIC" }, "Customer": { "type": "object", "properties": { "id": { "$ref": "#/components/schemas/CustomerID" } } }, "CustomerID": { "type": "number", "description": "Customer ID", "example": 867604 }, "DocumentNumber": { "type": "string", "description": "Cardholder document number. A government document number, such as a Social Security number (US) or Cadastro de Pessoas Físicas number (Brazil).", "example": "00011122233" }, "Email": { "type": "string", "description": "E-mail", "example": "ho_lee_smokes@gmail.com" }, "VCASInitiateActionRequest": { "type": "object", "required": [ "id", "provider", "type", "card", "account", "customer", "program", "raw_provider" ], "properties": { "id": { "$ref": "#/components/schemas/PismoAuthID" }, "provider": { "type": "string", "description": "Third-party provider name", "enum": [ "VCAS" ], "example": "VCAS" }, "type": { "type": "string", "description": "The type of operation to be performed.", "enum": [ "INITIATE_ACTION_CALL" ], "example": "INITIATE_ACTION_CALL" }, "card": { "$ref": "#/components/schemas/Card" }, "account": { "$ref": "#/components/schemas/AccountV2" }, "program": { "$ref": "#/components/schemas/Program" }, "customer": { "$ref": "#/components/schemas/Customer" }, "raw_provider": { "$ref": "#/components/schemas/RawProvider" } }, "example": { "id": "ff77635e-1cd6-4fda-992d-5ceb71d75644", "provider": "VCAS", "type": "INITIATE_ACTION_CALL", "card": { "id": 869572, "mode_id": 102, "type": "PLASTIC", "hash": "WEPvOQuZvjfYEd0iBmr43bhWyOsylIsW95ebYrLD89App2iEq9IizP+8w73pxKQ4mI47EdhzYHF9RfXjrBOyug==", "bin": "885692", "last_four_digits": "0153" }, "account": { "id": 10045896, "document_number": "00011122233", "phones": [ { "area_code": "31", "country_code": "55", "number": "998675309", "type": "mobile" } ], "email": "ho_lee_smokes@gmail.com" }, "program": { "id": 986 }, "customer": { "id": 867604 }, "raw_provider": { "ProcessorId": "5723ae630063ac1a9c3ab079", "IssuerId": "5723ae630063ac1a9c3ab654", "TransactionId": "00ec043e-40b5-4ce4-95c2-9e83b644f412", "DSTransactionId": "00ec043e-40b5-4ce4-95c2-9e83b644f258", "ThreeDSRequestorAuthenticationInd": "01", "StepupRequestId": "878f4751-4140-4881-9e4a-003e83524f22", "MessageVersion": "2.2.0", "RDXMessageVersion": "2.2.3", "MessageCategory": "01", "MerchantInfo": { "AcquirerId": "1337", "AcquirerCountryCode": "840", "MerchantId": "876543210", "MerchantName": "Ranier Expeditions", "MerchantURL": "https://www.requestor.com", "MerchantCategoryCode": "0123", "MerchantCountryCode": "840", "MerchantAppRedirectURL": "merchantScheme://appName?transID=b2385523-a66c-4907-ac3c-91848e8c0067" }, "TransactionInfo": { "TransactionCurrency": "840", "Channel": "WEB" } } } }, "VCASInitiateActionResponse": { "type": "object", "properties": { "raw_response": { "type": "object", "description": "Raw response to VCAS InitiateAction request, according with VCAS documentation.", "example": { "ProcessorId": "7723ae630063ac1a9c3ab07976", "IssuerId": "5723ae630063ac1a9c3ab080", "TransactionId": "00ec043e-40b5-4ce4-95c2-9e83b644f412", "StepupRequestId": "00ec043e-40b5-4ce4-95c2-9e83b644f412", "StepupType": "OTP", "Language": "string", "Status": "SUCCESS", "TransStatusReason": "string", "RiskIndicator": "string", "Credentials": [ { "Id": "d94fd3fd-bef1-49cb-88ab-a6841261cea9", "Type": "OTPEMAIL", "Text": "******@cardinalcommerce.com" } ], "Reason": { "ReasonCode": "string", "ReasonDescription": "string" }, "Error": { "ReferenceNumber": "string", "ReasonDescription": "string", "Description": "string", "Message": "string" } } } } }, "PANhash": { "type": "string", "description": "Encrypted PAN using 2048 rsa key and base64 encoded.\nPismo provides the encrypt/decrypt keys for this field.\n", "example": "WEPvOQuZvjfYEd0iBmr43bhWyOsylIsW95ebYrLD89App2iEq9IizP+8w73pxKQ4mI47EdhzYHF9RfXjrBOyug==" }, "StructuredPhone": { "type": "object", "description": "Phone number structure", "properties": { "area_code": { "type": "string", "description": "Area code of the phone number", "example": "31" }, "country_code": { "type": "string", "description": "Country code of the phone number", "example": "55" }, "number": { "type": "string", "description": "Phone number without area code", "example": "998675309" }, "type": { "type": "string", "description": "Type of phone number (e.g., mobile, commercial, residential)", "example": "mobile" } } }, "PismoAuthID": { "type": "string", "description": "Pismo-generated unique authentication ID", "example": "ff77635e-1cd6-4fda-992d-5ceb71d75644" }, "Program": { "type": "object", "properties": { "id": { "type": "integer", "example": 986, "description": "Program ID" } } }, "RawProvider": { "type": "object", "description": "All non-PCI information received from provider. Check provider documentation for details." } } }, "paths": { "/issuer-vcas-initiateaction-endpoint": { "post": { "summary": "Issuer’s endpoint to handle VCAs initiate action flow.", "description": "This endpoint will be used to inform the issuer about the initiate action flow in the VCAS process.", "operationId": "postInitiateAction", "tags": [ "VCAS" ], "requestBody": { "description": "Request provided by Pismo containing transaction and information", "required": true, "content": { "application/json": { "schema": { "$ref": "#/components/schemas/VCASInitiateActionRequest" } } } }, "responses": { "200": { "description": "OK", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/VCASInitiateActionResponse" } } } } } } } } } ```